
#include "conio.h"
#include "stdio.h"
#include "stdlib.h"
#include "math.h"

// numero di punti usati per effettuare il calcolo di pi greco
// con un metodo "montecarlo" (statistico)
#define NPUNTI  1000000

int main()
{
    float x, y, r, a;
    int cc;      // variabile di ciclo

    randomize();  // inizializzazione del generatore casuale
    a = 0.0;           // inizializzazione della variabile per il calcolo dell'area
    r = 5;        // raggio del cerchio, in base al quale calcolare pi-greco

    // ciclo di generazione di NPUNTI punti
    for (cc = 1; cc < NPUNTI; cc++)
    {
        // generazione di una coppia di coordinate x e y non intere
        x = (random(100000) / 100000.0) * r;
        y = (random(100000) / 100000.0) * r;

        // viene registrato che il punto e' caduto internamente
        // all'area del cerchio, se effettivamente la distanza dal centro
        // risulta minore di r
        if (sqrt(pow(x,2) + pow(y,2)) <= r)  a++;
    }

    // risultato della valutazione di pi-greco e calcolo dell'errore
    // (basato sul valore esatto registrato internamente a C++Builder)  
    printf("Il valore di pi greco risulta: %f \n\n", 4 * (a / NPUNTI));
    printf("Errore (%%) rispetto al valore teorico:  %f% \n\n",  (1 - (M_PI / (4 * (a / NPUNTI)))) * 100);

    getch();      // evita l'uscita dal programma

    return 0;
}

